<?php
/**
 * Migration Class
 *
 * @version     1.0.$Revision:$
 * @version     SVN: $Id:$
 * @package     bplan-base/globals
 * @subpackage  Migrations
 * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
 * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
 * @copyright   Copyright (C) 2025 bplan-solutions GmbH & Co. KG <https://www.bplan-solutions.de/>
 * /Δ\
 */


// use App\Enums\V2\SupportedSystemType;
use BplanBase\CodeGenerator\Loaders\CodeGenerator;
use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;


/**
 * Migration Class
 *
 * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
 * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
 */
return new class extends Migration
{

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('external_systems');

    } // down()


    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('external_systems', function (Blueprint $Table) {
            $Table->id();
            $Table->uuid('uuid');
            $Table->boolean('active')->default(1);

            $Table->timestamp('created_at');
            $Table->softDeletes('deleted_at');
            $Table->timestamp('updated_at');

            $Table->json('config_template')->nullable();
            $Table->text('description')->nullable();
            $Table->string('identifier', 20);
            $Table->string('label', 50);

            $Table->unique('uuid', 'external_systems_UKI_uuid');

            new CodeGenerator($Table, [
                'columns' => [
                    'config_template' => [
                        // @todo    Später (wenn dieses Feature implementiert wird) nochmal überprüfen ob der gewählte JsonType korrekt ist.
                        'jsonType' => CodeGenerator::JSON_TYPE_LOCALE_OBJECT,
                    ],
                    'identifier' => [
                        'guarded' => true,
                        'sortable' => true,
                    ],
                    'label' => [
                        'sortable' => true,
                    ],
                ],
                'exclude' => [
                    'laravel.permission-seeder',
                    'livewire.*',
                ],
                'indexQueries' => [
                    'terminal' => '$Query->where(\'active\', \'=\', 1)',
                ],
                'routing' => [
                    'terminal' => 'readOnly',
                ],

            ]);

        });
    } // up()

};
